## org.apache.commons.collections.bidimap
Class DualTreeBidiMap

    java.lang.Object
      org.apache.commons.collections.bidimap.AbstractDualBidiMap
          org.apache.commons.collections.bidimap.DualTreeBidiMap

All Implemented Interfaces:
  java.io.Serializable, java.util.Map, java.util.SortedMap, BidiMap, IterableMap, OrderedBidiMap, OrderedMap, SortedBidiMap

    public class DualTreeBidiMap

extends AbstractDualBidiMap
implements SortedBidiMap, java.io.Serializable

Implementation of `BidiMap` that uses two `TreeMap` instances.

The setValue() method on iterators will succeed only if the new value being set is not already in the bidimap.

When considering whether to use this class, the `TreeBidiMap` class should also be considered. It implements the interface using a dedicated design, and does not store each object twice, which can save on memory use.

NOTE: From Commons Collections 3.1, all subclasses will use `TreeMap` and the flawed `createMap` method is ignored.

Since:
  Commons Collections 3.0
Version:
  $Id: DualTreeBidiMap.java 646777 2008-04-10 12:33:15Z niallp $
Author:
  Matthew Hawthorne, Stephen Colebourne
See Also:
  Serialized Form

Nested Class Summary
`protected static class` `DualTreeBidiMap.BidiOrderedMapIterator` Inner class MapIterator.
`protected static class` `DualTreeBidiMap.ViewMap` Internal sorted map view.

Nested classes/interfaces inherited from class org.apache.commons.collections.bidimap.AbstractDualBidiMap
`AbstractDualBidiMap.BidiMapIterator, AbstractDualBidiMap.EntrySet, AbstractDualBidiMap.EntrySetIterator, AbstractDualBidiMap.KeySet, AbstractDualBidiMap.KeySetIterator, AbstractDualBidiMap.MapEntry, AbstractDualBidiMap.Values, AbstractDualBidiMap.ValuesIterator, AbstractDualBidiMap.View`

Nested classes/interfaces inherited from interface java.util.Map
`java.util.Map.Entry`

Nested classes/interfaces inherited from interface java.util.Map
`java.util.Map.Entry`

Field Summary
`protected java.util.Comparator` `comparator` The comparator to use

Fields inherited from class org.apache.commons.collections.bidimap.AbstractDualBidiMap
`entrySet, inverseBidiMap, keySet, maps, values`

Constructor Summary
`` `DualTreeBidiMap()` Creates an empty `DualTreeBidiMap`
`` `DualTreeBidiMap(java.util.Comparator comparator)` Constructs a `DualTreeBidiMap` using the specified Comparator.
`` `DualTreeBidiMap(java.util.Map map)` Constructs a `DualTreeBidiMap` and copies the mappings from specified `Map`.
`protected` `DualTreeBidiMap(java.util.Map normalMap, java.util.Map reverseMap, BidiMap inverseBidiMap)` Constructs a `DualTreeBidiMap` that decorates the specified maps.

Method Summary
`java.util.Comparator` `comparator()`
`protected BidiMap` `createBidiMap(java.util.Map normalMap, java.util.Map reverseMap, BidiMap inverseMap)` Creates a new instance of this object.
`java.lang.Object` `firstKey()` Gets the first key currently in this map.
`java.util.SortedMap` `headMap(java.lang.Object toKey)`
`OrderedBidiMap` `inverseOrderedBidiMap()` Gets a view of this map where the keys and values are reversed.
`SortedBidiMap` `inverseSortedBidiMap()` Gets a view of this map where the keys and values are reversed.
`java.lang.Object` `lastKey()` Gets the last key currently in this map.
`java.lang.Object` `nextKey(java.lang.Object key)` Gets the next key after the one specified.
`OrderedMapIterator` `orderedMapIterator()` Obtains an ordered map iterator.
`java.lang.Object` `previousKey(java.lang.Object key)` Gets the previous key before the one specified.
`java.util.SortedMap` `subMap(java.lang.Object fromKey, java.lang.Object toKey)`
`java.util.SortedMap` `tailMap(java.lang.Object fromKey)`

Methods inherited from class org.apache.commons.collections.bidimap.AbstractDualBidiMap
`clear, containsKey, containsValue, createEntrySetIterator, createKeySetIterator, createMap, createValuesIterator, entrySet, equals, get, getKey, hashCode, inverseBidiMap, isEmpty, keySet, mapIterator, put, putAll, remove, removeValue, size, toString, values`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface org.apache.commons.collections.SortedBidiMap
`inverseBidiMap`

Methods inherited from interface org.apache.commons.collections.BidiMap
`getKey, mapIterator, put, removeValue`

Methods inherited from interface java.util.Map
`clear, containsKey, containsValue, entrySet, equals, get, hashCode, isEmpty, keySet, putAll, remove, size, values`

Methods inherited from interface java.util.Map
`clear, containsKey, containsValue, entrySet, equals, get, hashCode, isEmpty, keySet, putAll, remove, size, values`

Field Detail

### comparator

    protected final java.util.Comparator comparator

  The comparator to use

Constructor Detail

### DualTreeBidiMap

    public DualTreeBidiMap()

  Creates an empty `DualTreeBidiMap`

### DualTreeBidiMap

    public DualTreeBidiMap(java.util.Map map)

  Constructs a `DualTreeBidiMap` and copies the mappings from specified `Map`.

  Parameters:
    `map` - the map whose mappings are to be placed in this map

### DualTreeBidiMap

    public DualTreeBidiMap(java.util.Comparator comparator)

  Constructs a `DualTreeBidiMap` using the specified Comparator.

  Parameters:
    `comparator` - the Comparator

### DualTreeBidiMap

    protected DualTreeBidiMap(java.util.Map normalMap,
                              java.util.Map reverseMap,
                              BidiMap inverseBidiMap)

  Constructs a `DualTreeBidiMap` that decorates the specified maps.

  Parameters:
    `normalMap` - the normal direction map
    `reverseMap` - the reverse direction map
    `inverseBidiMap` - the inverse BidiMap

Method Detail

### createBidiMap

    protected BidiMap createBidiMap(java.util.Map normalMap,
                                    java.util.Map reverseMap,
                                    BidiMap inverseMap)

  Creates a new instance of this object.

  Specified by:
    `createBidiMap` in class `AbstractDualBidiMap`
  Parameters:
    `normalMap` - the normal direction map
    `reverseMap` - the reverse direction map
    `inverseMap` - the inverse BidiMap
  Returns:
    new bidi map

### comparator

    public java.util.Comparator comparator()

  Specified by:
    `comparator` in interface `java.util.SortedMap`

### firstKey

    public java.lang.Object firstKey()

  Description copied from interface: `OrderedMap`
  Gets the first key currently in this map.

  Specified by:
    `firstKey` in interface `java.util.SortedMap`
  Specified by:
    `firstKey` in interface `OrderedMap`
  Returns:
    the first key currently in this map

### lastKey

    public java.lang.Object lastKey()

  Description copied from interface: `OrderedMap`
  Gets the last key currently in this map.

  Specified by:
    `lastKey` in interface `java.util.SortedMap`
  Specified by:
    `lastKey` in interface `OrderedMap`
  Returns:
    the last key currently in this map

### nextKey

    public java.lang.Object nextKey(java.lang.Object key)

  Description copied from interface: `OrderedMap`
  Gets the next key after the one specified.

  Specified by:
    `nextKey` in interface `OrderedMap`
  Parameters:
    `key` - the key to search for next from
  Returns:
    the next key, null if no match or at end

### previousKey

    public java.lang.Object previousKey(java.lang.Object key)

  Description copied from interface: `OrderedMap`
  Gets the previous key before the one specified.

  Specified by:
    `previousKey` in interface `OrderedMap`
  Parameters:
    `key` - the key to search for previous from
  Returns:
    the previous key, null if no match or at start

### orderedMapIterator

    public OrderedMapIterator orderedMapIterator()

  Obtains an ordered map iterator.

  This implementation copies the elements to an ArrayList in order to provide the forward/backward behaviour.

  Specified by:
    `orderedMapIterator` in interface `OrderedMap`
  Returns:
    a new ordered map iterator

### inverseSortedBidiMap

    public SortedBidiMap inverseSortedBidiMap()

  Description copied from interface: `SortedBidiMap`
  Gets a view of this map where the keys and values are reversed.

  Changes to one map will be visible in the other and vice versa. This enables both directions of the map to be accessed as a `SortedMap`.

  Implementations should seek to avoid creating a new object every time this method is called. See `AbstractMap.values()` etc. Calling this method on the inverse map should return the original.

  The inverse map returned by `inverseBidiMap()` should be the same object as returned by this method.

  Specified by:
    `inverseSortedBidiMap` in interface `SortedBidiMap`
  Returns:
    an inverted bidirectional map

### inverseOrderedBidiMap

    public OrderedBidiMap inverseOrderedBidiMap()

  Description copied from interface: `OrderedBidiMap`
  Gets a view of this map where the keys and values are reversed.

  Changes to one map will be visible in the other and vice versa. This enables both directions of the map to be accessed equally.

  Implementations should seek to avoid creating a new object every time this method is called. See `AbstractMap.values()` etc. Calling this method on the inverse map should return the original.

  Specified by:
    `inverseOrderedBidiMap` in interface `OrderedBidiMap`
  Returns:
    an inverted bidirectional map

### headMap

    public java.util.SortedMap headMap(java.lang.Object toKey)

  Specified by:
    `headMap` in interface `java.util.SortedMap`

### tailMap

    public java.util.SortedMap tailMap(java.lang.Object fromKey)

  Specified by:
    `tailMap` in interface `java.util.SortedMap`

### subMap

    public java.util.SortedMap subMap(java.lang.Object fromKey,
                                      java.lang.Object toKey)

  Specified by:
    `subMap` in interface `java.util.SortedMap`

Copyright © 2001-2008 The Apache Software Foundation. All Rights Reserved.